hdu 3342(拓扑排序)

来源:互联网 发布:java怎么做ftp文件同步 编辑:程序博客网 时间:2024/06/07 09:42

Legal or Not

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 6543    Accepted Submission(s): 3058


Problem Description
ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many "holy cows" like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost "master", and Lost will have a nice "prentice". By and by, there are many pairs of "master and prentice". But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

We all know a master can have many prentices and a prentice may have a lot of masters too, it's legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian's master and, at the same time, 3xian is HH's master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not. 

Please note that the "master and prentice" relation is transitive. It means that if A is B's master ans B is C's master, then A is C's master.
 

Input
The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y's master and y is x's prentice. The input is terminated by N = 0.
TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,..., N-1). We use their numbers instead of their names.
 

Output
For each test case, print in one line the judgement of the messy relationship.
If it is legal, output "YES", otherwise "NO".
 

Sample Input
3 20 11 22 20 11 00 0
 

Sample Output
YESNO

题意:如果a是b的师傅,b是c的师傅,那么a是c的师傅,但是如果c又是a师傅,那么此时就不合法了,应当输出NO,否则合法的话就输出YES。

其实就是判断一个有向图是否存在环,如果存在那么显然关系就是不合法的,不存在环那关系肯定合法呀。

所以用拓扑排序来一层层的去掉最外层的皮,看最后是否有剩下的,如果有那肯定就是存在环咯。


#include <iostream>#include <stdio.h>#include <stdlib.h>#include<string.h>#include<algorithm>#include<math.h>using namespace std;typedef long long ll;int a[105][105],r[105];void topu(int n){    int rr=0,s=0,flag=0;    while(rr<n&&!flag)    {        flag=1;        for(int i=0;i<n;i++)        if(r[i]==0)        {            s++;            flag=0;            r[i]--;            for(int j=0;j<n;j++)                if(a[i][j])                r[j]--;            break;        }    }    if(s==n)        printf("YES\n");    else printf("NO\n");}int main(){    int n,m;    while(cin>>n>>m&&n)    {        memset(a,0,sizeof(a));        memset(r,0,sizeof(r));        for(int i=0;i<m;i++)        {            int x,y;            cin>>x>>y;            if(!a[x][y])            a[x][y]=1,r[y]++;        }        topu(n);    }    return 0;}


0 0
原创粉丝点击